
#include <SoftwareSerial.h>


int rx  = 0;  //
int tx  = 1;  //
int prn = A0; //PON_RST_N           O - Module reset
int mwa = 4;  //MODULE_WAKEUP_AP    I - Module wakes up AP
int mp  = 5;  //MODULE_POWERON      I - Module power-on status
int mr  = 6;  //MODULE_READY        I - AP queries Module sleep status
int ar  = 7;  //AP_READY            O - Module queries AP sleep status
int awm = 8;  //AP_WAKEUP_MODULE    O - AP wakes up Module
int po  = 9;  //POWER_ON            O - Power-on/Power-off


int sw_rx = 10;
int sw_tx = 11;
SoftwareSerial mySerial(sw_rx, sw_tx); // RX, TX


unsigned long time;
int ledThreshold = 200;

// the setup routine runs once when you press reset:
void setup() {
  Serial.begin(115200);
  mySerial.begin(115200);
  mySerial.println("");
  
  pinMode(prn, OUTPUT);
  pinMode(mwa, INPUT);
  pinMode(mp,  INPUT);
  pinMode(mr,  INPUT);
  pinMode(ar,  OUTPUT);
  pinMode(awm, OUTPUT);
  pinMode(po,  OUTPUT);
  
  digitalWrite(prn, HIGH);    //no reset (toggle to reset)
  digitalWrite(ar,  LOW);     //AP is awake
  digitalWrite(awm, LOW);     //AP wakes up module
  digitalWrite(po,  HIGH);    //high is awake (toggle later to turn on/off)
  
  delay(2000);
  //debug_inputs();
  mySerial.println("TURN ON!");
  //delay(1000);
  po_turnOn();
  delay(5000);
  Serial.println("SETUP COMPLETE!");
}


String inputString = "";         // a string to hold incoming data
int inputStringLen = 0;

// the loop routine runs over and over again forever:
void loop() {
  Serial.println("\n\n--------------------");
  Serial.print("Time: ");
  time = millis()/1000;
  Serial.println(time);         //prints time since program started
  
  led_read();
  delay(500);
  
  debug_inputs();
  delay(500);
  
  cell_echoEnable();
  delay(500);
  
  cell_module();
  delay(2500);
  
//  cell_status();
//  delay(500);
  
  char temp1[11] = {'a', 't', 'e', '1', 0x0d, 0x0d, 0x0a, 'O', 'K', 0x0d, 0x0a};
  util_checkString(temp1, 11);
  char temp2[9] = {'a', 't', 0x0d, 0x0d, 0x0a, 'O', 'K', 0x0d, 0x0a};
  util_checkString(temp2, 9);
  
  util_printString();
  
  delay(2500);
}

void serialEvent() {
  while (Serial.available()) {
    // get the new byte:
    char inChar = (char)Serial.read();
    // add it to the inputString:
    inputString += inChar;
    inputStringLen++;
    
    //mySerial.print(">>>");
    //mySerial.println(inChar, HEX);
  }
}

void util_printString() {
  if (inputString != "") {
    mySerial.println(inputString);
    // clear the string:
    inputString = "";
    inputStringLen = 0;
    mySerial.println("---------");
  }
}
int util_checkString(String test, int len) {
  //mySerial.println("1====================");
  //String second = test;
  //second.replace(0x0a, ' ');
  //second.replace(0x0d, ' ');
  
  //for (int i=0; i<len; i++) {
  //    mySerial.print(i);
  //    mySerial.print(" ");
  //    mySerial.print(second[i]);
  //    mySerial.print(" ");
  //    mySerial.println(second[i], HEX);
  //}
  //mySerial.println("2====================");

  //mySerial.println("-->");
  //mySerial.println(second);
  //mySerial.println("-->");
  //mySerial.print(" - ");

  Serial.println("");
  if(util_matchString(test, len)) {
    Serial.println("Response Check: TRUE");
    return 1;
  }
  Serial.println("Response Check: FALSE");
  return 0;
}

int util_matchString(String test, int len) {
  int index = 0;
  int index2 = 0;
  int truth = 0;
  if (len < inputStringLen) {
    while ((index < inputStringLen)&&(index2 < len)) {
      if (test[index2] == inputString[index++]) {

        //mySerial.print(" T-");
        //mySerial.print(test[index2], HEX);
        //mySerial.print(" ");
        //mySerial.println(inputString[index-1], HEX);

        truth = 1;
        index2++;
      }
      else {
        truth = 0;
        index2 = 0;
      }
    }
    if ((truth == 1) && (index2  == len)) {
      return 1;
    }
  }
  return 0;
}
