void po_turnOn() {
  delay(100);
  digitalWrite(po,  LOW);
  delay(100);
  digitalWrite(po,  HIGH);
}

void po_turnOff() {
  delay(100);
  digitalWrite(po,  LOW);
  delay(5100);
  digitalWrite(po,  HIGH);
}

void prn_toggle() {
  delay(100);
  digitalWrite(prn,  LOW);
  delay(200);
  digitalWrite(prn,  HIGH);
}

void led_read() {
  //This yields a resolution between readings of: 5 volts / 1024 units or, .0049 volts (4.9 mV) per unit
  int ledB = analogRead(3);    // read the input pin
  Serial.print("LED Analog BLUE (3G): ");
  Serial.print(ledB);             // debug value
  if (ledB > ledThreshold) {
    Serial.println(" OFF");
  }
  else {
    Serial.println(" ON");
  }
  
  int ledR = analogRead(2);    // read the input pin
  Serial.print("LED Analog RED (Unregistered): ");
  Serial.print(ledR);             // debug value
  if (ledR > ledThreshold) {
    Serial.println(" OFF");
  }
  else {
    Serial.println(" ON");
  }
  
  int ledG = analogRead(1);    // read the input pin
  Serial.print("LED Analog GREEN (2G): ");
  Serial.print(ledG);             // debug value
  if (ledG > ledThreshold) {
    Serial.println(" OFF");
  }
  else {
    Serial.println(" ON");
  }
}

void debug_inputs() {  
  Serial.print("Module Wakeup AP: ");
  int buttonStateMWA = digitalRead(mwa);
  Serial.print(buttonStateMWA);
  if (buttonStateMWA == 0) {
    Serial.println(" - Wakeup");
  }
  else {
    Serial.println(" - Awake");
  }
  delay(1);        // delay in between reads for stability
  
  Serial.print("Module Poweron: ");
  int buttonStateMP = digitalRead(mp);
  Serial.print(buttonStateMP);
  if (buttonStateMP == 0) {
    Serial.println(" - Off");
  }
  else {
    Serial.println(" - On");
  }
  delay(1);        // delay in between reads for stability
  
  Serial.print("Module Ready: ");
  int buttonStateMR = digitalRead(mr);
  Serial.print(buttonStateMR);
  if (buttonStateMR == 0) {
    Serial.println(" - Awake");
  }
  else {
    Serial.println(" - Asleep");
  }
  delay(1);        // delay in between reads for stability
  
  Serial.println("--------------------");
  Serial.print("***** MODULE: ");
  if ((buttonStateMWA == 1) && (buttonStateMP == 1)) {// && (buttonStateMR == 0)) {
    Serial.print("ALL GOOD :)");
  }
  else {
    Serial.print("ERROR :(");
  }
  Serial.println("");

  /*
  STAGES
  1) Module on
  Module Wakeup AP: 1
  Module Poweron: 1
  Module Ready: 0
  */
}

void cell_echoEnable() {
  Serial.print("ate1\r");
}
void cell_echoDisable() {
  Serial.print("ate0\r");
}
void cell_status() {
  Serial.print("at+cpin?\r");
}
void cell_module() {
  Serial.print("at\r");
}
//Serial.println("at+cpin?\x1A");

